<?php
/**
*
* @package Ultimate Points
* @version $Id: points_mylinks.php 665 2010-11-14 04:30:21Z femu $
* @copyright (c) 2009 wuerzi & femu
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*
*/

/**
* @ignore
*/
if (!defined('IN_PHPBB'))
{
	exit;
}

/**
* @package Ultimate Points
*/
class points_mylinks
{
	var $u_action;

	function main($id, $mode)
	{
		global $template, $user, $db, $config, $phpEx, $phpbb_root_path, $ultimate_points, $points_config, $points_values, $auth, $checked_user, $check_auth;

		// Check if user is allowed to use the logs
		if (!$auth->acl_get('u_use_logs'))
		{
			$message = $user->lang['NOT_AUTHORISED'] . '<br /><br /><a href="' . append_sid("{$phpbb_root_path}points.$phpEx") . '">&laquo; ' . $user->lang['BACK_TO_PREV'] . '</a>';
			trigger_error($message);
		}

		// Add part to bar
		$template->assign_block_vars('navlinks', array(
			'U_VIEW_FORUM'	=> append_sid("{$phpbb_root_path}points.$phpEx", "mode=mylinks"),
			'FORUM_NAME'	=> $user->lang['POINTS_LINK'],
		));
		
		// Dirigir a pagina sleccioanda
		$enlaza_mode = request_var('enlaza', '');

		if (!$enlaza_mode)
		{
			// INICIO -- Enlaces que he Comprado
			$start 			= request_var('start', 0);
			$number 		= $points_values['number_show_per_page'];

			$sort_days		= request_var('st', 0);
			$sort_key		= request_var('sk', 'crono');
			$sort_dir		= request_var('sd', 'd');
			$limit_days 	= array(0 => $user->lang['ALL_POSTS'], 1 => $user->lang['1_DAY'], 7 => $user->lang['7_DAYS'], 14 => $user->lang['2_WEEKS'], 30 => $user->lang['1_MONTH'], 90 => $user->lang['3_MONTHS'], 180 => $user->lang['6_MONTHS'], 365 => $user->lang['1_YEAR']);

			$sort_by_text	= array('crono' => $user->lang['POINTS_ORD_CRONO'], 'coste' => $user->lang['POINTS_PRICE_PAY'], 'propi' => $user->lang['POINTS_OWNER']);
			$sort_by_sql 	= array('crono' => 'link_id', 'coste' => 'link_cost', 'propi' => 'user_id_prop');

			$s_limit_days = $s_sort_key = $s_sort_dir = $u_sort_param = '';
			gen_sort_selects($limit_days, $sort_by_text, $sort_days, $sort_key, $sort_dir, $s_limit_days, $s_sort_key, $s_sort_dir, $u_sort_param);
			$sql_sort_order = $sort_by_sql[$sort_key] . ' ' . (($sort_dir == 'd') ? 'DESC' : 'ASC');

			$id_conec 		= (int) $user->data['user_id'];
			// Usuario Conectado			
			$sql_array3 = array(
				'SELECT'    => '*',
				'FROM'      => array(
					USERS_TABLE => 'u',
				),
				'WHERE'		=> 'user_id = ' . $id_conec,
			);
			$sql3 = $db->sql_build_query('SELECT', $sql_array3);
			$result3 = $db->sql_query($sql3);
			$conec = $db->sql_fetchrow($result3);
			$db->sql_freeresult($result3);
			$id_conec_name 	= $conec['username'];				
			
			// Total de enlaces comprados por el usuario conectado
			$sql = "SELECT COUNT(*) AS total FROM phpbb_payforlink WHERE user_id_buy = '$id_conec'";
			$result = $db->sql_query($sql);
			$max = (int) $db->sql_fetchfield('total');		

			// Captura de todos los enlaces comprados por el usuario conectado
			$sql = "SELECT * FROM phpbb_payforlink WHERE user_id_buy = '$id_conec' ORDER BY " . $sql_sort_order;
			$result = $db->sql_query_limit($sql, $number, $start);

			// Start looping all the enlaces
			$total_points = 0;		
			$rows = false;
			while ($row = $db->sql_fetchrow($result))
			{

				// Decodificamos la URL del enlace
				$goback_url		= strrev($row['link_url']);
				$clear_url		= DecodeID($goback_url);
				$datos 			= explode('|||',$clear_url);
				$url 			= '<a href="'.$datos[0].'" target="_blank">'.$datos[0].'</a>';
						
				$subject_post 	= '<form method="post" action="'.$phpbb_root_path.'search.php?keywords='.$row['link_url'].'&sf=msgonly" name="'.$row['link_id'].'">
				<div align="center"><input class="button2" value="'.$user->lang['SEARCH'].'" type="submit" /></div></form>';
									
				// Usuario Propietario			
				$sql_array2 = array(
					'SELECT'    => '*',
					'FROM'      => array(
						USERS_TABLE => 'u',
					),
					'WHERE'		=> 'user_id = ' . (int) $row['user_id_prop'],
				);
				$sql2 = $db->sql_build_query('SELECT', $sql_array2);
				$result12 = $db->sql_query($sql2);
				$owner = $db->sql_fetchrow($result12);
				$db->sql_freeresult($result12);
				
				$to = get_username_string('full', $owner['user_id'], $owner['username'], $owner['user_colour']);
				$rows = (!$rows) ? true : false;	
				$total_points = $total_points + $row['link_cost'];
				
				// Add the items to the template
				$template->assign_block_vars('logs', array(
					'OWNER'			=>	$to,			
					'LINK'			=>	$url,
					'SUBJECT'		=>	$subject_post,
					'COST'			=>	$row['link_cost'] . '&nbsp;' . $user->lang['POINTS_POINTS'],		
					'S_ROW_COUNT'	=>	$rows,
				));
			}
			$db->sql_freeresult($result);

			// Generate the page template
			$template->assign_vars(array(
				'PAGINATION'		=> generate_pagination(append_sid("{$phpbb_root_path}points.$phpEx", "mode=mylinks&amp;sk=$sort_key&amp;sd=$sort_dir"), $max, $number, $start),
				'PAGE_NUMBER' 		=> on_page($max, $number, $start),
				'ENLACES_X_PAGINA' 	=> (($max - $start) < $number ) ? ($max - $start) : $number,
				'TOTAL_POINTS' 		=> $total_points,
				'LOTTERY_NAME'		=> $points_values['lottery_name'],
				'BANK_NAME'			=> $points_values['bank_name'],

				'L_TOTAL_ENTRIES'	=> ($max == 1) ? $user->lang['POINTS_LOG_SINGLE'] : sprintf($user->lang['POINTS_LOG_MULTI'], $max),
				
				'S_VIEW_BUY'		=> true,
				'POINTS_TITLE'		=> $user->lang['POINTS_LIST_LINKS_BUY'],					
				'POINTS_COLUM1'		=> $user->lang['POINTS_OWNER'],
				'POINTS_COLUM2'		=> $user->lang['POINTS_LINK'],
				'POINTS_COLUM3'		=> $user->lang['POINTS_LINK_LOCATED'],
				'POINTS_COLUM4'		=> $user->lang['POINTS_LINK_PAY'],
				'POINTS_TOT'		=> $user->lang['POINTS_TOT_PAY'],	
					
				'S_LOGS_ACTION' 	=> append_sid("{$phpbb_root_path}points.$phpEx", "mode=mylinks"),
				'S_SELECT_SORT_DIR'	=> $s_sort_dir,
				'S_SELECT_SORT_KEY'	=> $s_sort_key,

				'U_TRANSFER_USER'	=> append_sid("{$phpbb_root_path}points.$phpEx", "mode=transfer_user"),
				'U_LOGS'			=> append_sid("{$phpbb_root_path}points.$phpEx", "mode=logs"),
				'U_LOTTERY'			=> append_sid("{$phpbb_root_path}points.$phpEx", "mode=lottery"),
				'U_BANK'			=> append_sid("{$phpbb_root_path}points.$phpEx", "mode=bank"),
				'U_ROBBERY'			=> append_sid("{$phpbb_root_path}points.$phpEx", "mode=robbery"),
				'U_INFO'			=> append_sid("{$phpbb_root_path}points.$phpEx", "mode=info"),
				'U_MY_BUY'			=> append_sid("{$phpbb_root_path}points.$phpEx", "mode=mylinks"),
				'U_MY_PAY'			=> append_sid("{$phpbb_root_path}points.$phpEx", "mode=mylinks&amp;enlaza=pay"),
				'U_MY_MEE'			=> append_sid("{$phpbb_root_path}points.$phpEx", "mode=mylinks&amp;enlaza=mee"),
				'U_MY_ALL'			=> append_sid("{$phpbb_root_path}points.$phpEx", "mode=mylinks&amp;enlaza=all"),				
				'U_USE_TRANSFER'	=> $auth->acl_get('u_use_transfer'),
				'U_USE_LOGS'		=> $auth->acl_get('u_use_logs'),
				'U_USE_LOTTERY'		=> $auth->acl_get('u_use_lottery'),
				'U_USE_BANK'		=> $auth->acl_get('u_use_bank'),
				'U_USE_ROBBERY'		=> $auth->acl_get('u_use_robbery'),	
			));
		} else {
			// Check, Quien ha Comprado mis Enlaces???
			if ($enlaza_mode == 'pay')
			{
				// INICIO -- Enlaces mios que han Comprado
				$start 			= request_var('start', 0);
				$number 		= $points_values['number_show_per_page'];

				$sort_days		= request_var('st', 0);
				$sort_key		= request_var('sk', 'crono');
				$sort_dir		= request_var('sd', 'd');
				$limit_days 	= array(0 => $user->lang['ALL_POSTS'], 1 => $user->lang['1_DAY'], 7 => $user->lang['7_DAYS'], 14 => $user->lang['2_WEEKS'], 30 => $user->lang['1_MONTH'], 90 => $user->lang['3_MONTHS'], 180 => $user->lang['6_MONTHS'], 365 => $user->lang['1_YEAR']);

				$sort_by_text	= array('crono' => $user->lang['POINTS_ORD_CRONO'], 'ganado' => $user->lang['POINTS_ORD_GAIN'], 'comprador' => $user->lang['POINTS_BUYER']);
				$sort_by_sql 	= array('crono' => 'link_id', 'ganado' => 'link_cost', 'comprador' => 'user_id_buy');

				$s_limit_days = $s_sort_key = $s_sort_dir = $u_sort_param = '';
				gen_sort_selects($limit_days, $sort_by_text, $sort_days, $sort_key, $sort_dir, $s_limit_days, $s_sort_key, $s_sort_dir, $u_sort_param);
				$sql_sort_order = $sort_by_sql[$sort_key] . ' ' . (($sort_dir == 'd') ? 'DESC' : 'ASC');

				$id_conec 		= (int) $user->data['user_id'];
				// Usuario Conectado			
				$sql_array3 = array(
					'SELECT'    => '*',
					'FROM'      => array(
						USERS_TABLE => 'u',
					),
					'WHERE'		=> 'user_id = ' . $id_conec,
				);
				$sql3 = $db->sql_build_query('SELECT', $sql_array3);
				$result3 = $db->sql_query($sql3);
				$conec = $db->sql_fetchrow($result3);
				$db->sql_freeresult($result3);
				$id_conec_name 	= $conec['username'];				
				
				// Total de enlaces comprados que han sido creados por el usuario conectado
				$sql = "SELECT COUNT(*) AS total FROM phpbb_payforlink WHERE user_id_prop = '$id_conec'";
				$result = $db->sql_query($sql);
				$max = (int) $db->sql_fetchfield('total');		

				// Captura de todos los enlaces comprados que han sido creados por el usuario conectado
				$sql = "SELECT * FROM phpbb_payforlink WHERE user_id_prop = '$id_conec' ORDER BY " . $sql_sort_order;
				$result = $db->sql_query_limit($sql, $number, $start);

				// Start looping all the enlaces
				$total_points = 0;		
				$rows = false;
				while ($row = $db->sql_fetchrow($result))
				{

					// Decodificamos la URL del enlace
					$goback_url		= strrev($row['link_url']);
					$clear_url		= DecodeID($goback_url);
					$datos 			= explode('|||',$clear_url);
					$url 			= '<a href="'.$datos[0].'" target="_blank">'.$datos[0].'</a>';
							
					$subject_post 	= '<form method="post" action="'.$phpbb_root_path.'search.php?keywords='.$row['link_url'].'&sf=msgonly" name="'.$row['link_id'].'">
					<div align="center"><input class="button2" value="'.$user->lang['SEARCH'].'" type="submit" /></div></form>';
										
					// Usuario Comprador			
					$sql_array2 = array(
						'SELECT'    => '*',
						'FROM'      => array(
							USERS_TABLE => 'u',
						),
						'WHERE'		=> 'user_id = ' . (int) $row['user_id_buy'],
					);
					$sql2 = $db->sql_build_query('SELECT', $sql_array2);
					$result12 = $db->sql_query($sql2);
					$buyer = $db->sql_fetchrow($result12);
					$db->sql_freeresult($result12);
					
					$to = get_username_string('full', $buyer['user_id'], $buyer['username'], $buyer['user_colour']);
					$rows = (!$rows) ? true : false;	
					$total_points = $total_points + $row['link_cost'];
					
					// Add the items to the template
					$template->assign_block_vars('logs', array(
						'OWNER'			=>	$to,			
						'LINK'			=>	$url,
						'SUBJECT'		=>	$subject_post,
						'COST'			=>	$row['link_cost'] . '&nbsp;' . $user->lang['POINTS_POINTS'],		
						'S_ROW_COUNT'	=>	$rows,
					));
				}
				$db->sql_freeresult($result);

				// Generate the page template
				$template->assign_vars(array(
					'PAGINATION'		=> generate_pagination(append_sid("{$phpbb_root_path}points.$phpEx", "mode=mylinks&amp;enlaza=pay&amp;sk=$sort_key&amp;sd=$sort_dir"), $max, $number, $start),
					'PAGE_NUMBER' 		=> on_page($max, $number, $start),
					'ENLACES_X_PAGINA' 	=> (($max - $start) < $number ) ? ($max - $start) : $number,
					'TOTAL_POINTS' 		=> $total_points,
					'LOTTERY_NAME'		=> $points_values['lottery_name'],
					'BANK_NAME'			=> $points_values['bank_name'],

					'L_TOTAL_ENTRIES'	=> ($max == 1) ? $user->lang['POINTS_LOG_SINGLE'] : sprintf($user->lang['POINTS_LOG_MULTI'], $max),
					
					'S_VIEW_BUY'		=> true,
					'POINTS_TITLE'		=> $user->lang['POINTS_LIST_LINKS_PAY'],					
					'POINTS_COLUM1'		=> $user->lang['POINTS_BUYER'],
					'POINTS_COLUM2'		=> $user->lang['POINTS_LINK'],
					'POINTS_COLUM3'		=> $user->lang['POINTS_LINK_LOCATED'],
					'POINTS_COLUM4'		=> $user->lang['POINTS_LINK_BUY'],
					'POINTS_TOT'		=> $user->lang['POINTS_TOT_BUY'],					
					
					'S_LOGS_ACTION' 	=> append_sid("{$phpbb_root_path}points.$phpEx", "mode=mylinks&amp;enlaza=pay"),
					'S_SELECT_SORT_DIR'	=> $s_sort_dir,
					'S_SELECT_SORT_KEY'	=> $s_sort_key,

					'U_TRANSFER_USER'	=> append_sid("{$phpbb_root_path}points.$phpEx", "mode=transfer_user"),
					'U_LOGS'			=> append_sid("{$phpbb_root_path}points.$phpEx", "mode=logs"),
					'U_LOTTERY'			=> append_sid("{$phpbb_root_path}points.$phpEx", "mode=lottery"),
					'U_BANK'			=> append_sid("{$phpbb_root_path}points.$phpEx", "mode=bank"),
					'U_ROBBERY'			=> append_sid("{$phpbb_root_path}points.$phpEx", "mode=robbery"),
					'U_INFO'			=> append_sid("{$phpbb_root_path}points.$phpEx", "mode=info"),
					'U_MY_BUY'			=> append_sid("{$phpbb_root_path}points.$phpEx", "mode=mylinks"),
					'U_MY_PAY'			=> append_sid("{$phpbb_root_path}points.$phpEx", "mode=mylinks&amp;enlaza=pay"),
					'U_MY_MEE'			=> append_sid("{$phpbb_root_path}points.$phpEx", "mode=mylinks&amp;enlaza=mee"),
					'U_MY_ALL'			=> append_sid("{$phpbb_root_path}points.$phpEx", "mode=mylinks&amp;enlaza=all"),					
					'U_USE_TRANSFER'	=> $auth->acl_get('u_use_transfer'),
					'U_USE_LOGS'		=> $auth->acl_get('u_use_logs'),
					'U_USE_LOTTERY'		=> $auth->acl_get('u_use_lottery'),
					'U_USE_BANK'		=> $auth->acl_get('u_use_bank'),
					'U_USE_ROBBERY'		=> $auth->acl_get('u_use_robbery'),	
				));			
			}		

			// Check, Todos Mis Enlaces
			if ($enlaza_mode == 'mee')
			{
				// INICIO -- Todos Mis Enlaces
				$start 			= request_var('start', 0);
				$number 		= $points_values['number_show_per_page'];

				$sort_days		= request_var('st', 0);
				$sort_key		= request_var('sk', 'crono');
				$sort_dir		= request_var('sd', 'd');
				$limit_days 	= array(0 => $user->lang['ALL_POSTS'], 1 => $user->lang['1_DAY'], 7 => $user->lang['7_DAYS'], 14 => $user->lang['2_WEEKS'], 30 => $user->lang['1_MONTH'], 90 => $user->lang['3_MONTHS'], 180 => $user->lang['6_MONTHS'], 365 => $user->lang['1_YEAR']);

				$sort_by_text	= array('crono' => $user->lang['POINTS_ORD_CRONO'], 'creador' => $user->lang['POINTS_LINK_CREATOR'], 'asunto' => $user->lang['POINTS_ORD_SUBJECT']);
				$sort_by_sql 	= array('crono' => 'post_time', 'creador' => 'poster_id', 'asunto' => 'post_subject');

				$s_limit_days = $s_sort_key = $s_sort_dir = $u_sort_param = '';
				gen_sort_selects($limit_days, $sort_by_text, $sort_days, $sort_key, $sort_dir, $s_limit_days, $s_sort_key, $s_sort_dir, $u_sort_param);
				$sql_sort_order = $sort_by_sql[$sort_key] . ' ' . (($sort_dir == 'd') ? 'DESC' : 'ASC');

				$id_conec 		= (int) $user->data['user_id'];
				// Usuario Conectado			
				$sql_array3 = array(
					'SELECT'    => '*',
					'FROM'      => array(
						USERS_TABLE => 'u',
					),
					'WHERE'		=> 'user_id = ' . $id_conec,
				);
				$sql3 = $db->sql_build_query('SELECT', $sql_array3);
				$result3 = $db->sql_query($sql3);
				$conec = $db->sql_fetchrow($result3);
				$db->sql_freeresult($result3);
				$id_conec_name 	= $conec['username'];

				// Busca en TODOS los post cualquier URL codificada			
				$buscame = '[payforlink:';
				$sql7 = "SELECT post_id FROM phpbb_posts WHERE post_text LIKE '%$buscame%' ORDER BY " . $sql_sort_order;
				$result7 = $db->sql_query($sql7);
				
				$total_points = $max = $contados = 0;		
				$rows = false;
				while ($row7 = $db->sql_fetchrow($result7))
				{
					$to = $subject_post = $url_tot = '';
					
					// Coge uno a uno los valores de los pots hallados
					$sql = "SELECT post_id, poster_id, post_subject, post_text, bbcode_uid FROM phpbb_posts WHERE post_id = '$row7[post_id]'";
					$result = $db->sql_query($sql);
					$row = $db->sql_fetchrow($result);
					$db->sql_freeresult($result);
					
					$textodelpost = $row['post_text'];
					decode_message($textodelpost, $row['bbcode_uid']);				
					$links = '';
					$links = Return_Substrings($textodelpost, '[payforlink]', '[/payforlink]');

					// Todas las URL de enlaces codificadas dentro de un mensaje
					for($i=0; $i<count($links);$i++)
					{
						// Decodificamos la URL del enlace
						$goback_url		= strrev($links[$i]);
						$clear_url		= DecodeID($goback_url);
						$datos 			= explode('|||',$clear_url);
						$url 			= $datos[0];
						$precio 		= $datos[1];
						$id_prop 		= $datos[2];
						
						// Verificamos que el enlace es propiedad del usuario conectado
						if ($id_conec == $id_prop)
						{					
						$max++;
							// Solo imprime el rango comprendido desde start con un maximo de number
							if (($max > $start) and ($number > $contados))
							{
							$contados++;
								// Usuario Creador del Hilo			
								$sql_array2 = array(
									'SELECT'    => '*',
									'FROM'      => array(
										USERS_TABLE => 'u',
									),
									'WHERE'		=> 'user_id = ' . (int) $row['poster_id'],
								);
								$sql2 = $db->sql_build_query('SELECT', $sql_array2);
								$result12 = $db->sql_query($sql2);
								$buyer = $db->sql_fetchrow($result12);
								$db->sql_freeresult($result12);

								$url_tot = '<a href="'.$url.'" target="_blank">'.$url.'</a>';
								if ($row['post_subject'] == '')
								{
									$subject_post = '<a href="'.$phpbb_root_path.'viewtopic.php?p='.$row['post_id'].'#p'.$row['post_id'].'">'.$user->lang['POINTS_LINK_NO_SUBJECT'].'</a><br>';								
								} else {
									$subject_post = '<a href="'.$phpbb_root_path.'viewtopic.php?p='.$row['post_id'].'#p'.$row['post_id'].'">'.$row['post_subject'].'</a><br>';
								}
								$to = get_username_string('full', $buyer['user_id'], $buyer['username'], $buyer['user_colour']);
								$rows = (!$rows) ? true : false;	
								$total_points = $total_points + $precio;
								
								// Add the items to the template
								$template->assign_block_vars('logs', array(
									'OWNER'			=>	$url_tot,
									'LINK'			=>	$subject_post,
									'SUBJECT'		=>	$to,						
									'COST'			=>	$precio . '&nbsp;' . $user->lang['POINTS_POINTS'],		
									'S_ROW_COUNT'	=>	$rows,
								));

							}	
						}
					}	
				}
				$db->sql_freeresult($result7);

				// Generate the page template
				$template->assign_vars(array(
					'PAGINATION'		=> generate_pagination(append_sid("{$phpbb_root_path}points.$phpEx", "mode=mylinks&amp;enlaza=mee&amp;sk=$sort_key&amp;sd=$sort_dir"), $max, $number, $start),
					'PAGE_NUMBER' 		=> on_page($max, $number, $start),
					'ENLACES_X_PAGINA' 	=> (($max - $start) < $number ) ? ($max - $start) : $number,
					'TOTAL_POINTS' 		=> $total_points,
					'LOTTERY_NAME'		=> $points_values['lottery_name'],
					'BANK_NAME'			=> $points_values['bank_name'],

					'L_TOTAL_ENTRIES'	=> ($max == 1) ? $user->lang['POINTS_LOG_SINGLE'] : sprintf($user->lang['POINTS_LOG_MULTI'], $max),
					
					'S_VIEW_BUY'		=> true,
					'POINTS_TITLE'		=> $user->lang['POINTS_LIST_LINKS_MEE'],					
					'POINTS_COLUM1'		=> $user->lang['POINTS_LINK'],
					'POINTS_COLUM2'		=> $user->lang['POINTS_LINK_LOCATED'],
					'POINTS_COLUM3'		=> $user->lang['POINTS_LINK_CREATOR'],
					'POINTS_COLUM4'		=> $user->lang['POINTS_POINTS'],
					'POINTS_TOT'		=> $user->lang['POINTS_TOT_MEE'],					
					
					'S_LOGS_ACTION' 	=> append_sid("{$phpbb_root_path}points.$phpEx", "mode=mylinks&amp;enlaza=mee"),
					'S_SELECT_SORT_DIR'	=> $s_sort_dir,
					'S_SELECT_SORT_KEY'	=> $s_sort_key,

					'U_TRANSFER_USER'	=> append_sid("{$phpbb_root_path}points.$phpEx", "mode=transfer_user"),
					'U_LOGS'			=> append_sid("{$phpbb_root_path}points.$phpEx", "mode=logs"),
					'U_LOTTERY'			=> append_sid("{$phpbb_root_path}points.$phpEx", "mode=lottery"),
					'U_BANK'			=> append_sid("{$phpbb_root_path}points.$phpEx", "mode=bank"),
					'U_ROBBERY'			=> append_sid("{$phpbb_root_path}points.$phpEx", "mode=robbery"),
					'U_INFO'			=> append_sid("{$phpbb_root_path}points.$phpEx", "mode=info"),
					'U_MY_BUY'			=> append_sid("{$phpbb_root_path}points.$phpEx", "mode=mylinks"),
					'U_MY_PAY'			=> append_sid("{$phpbb_root_path}points.$phpEx", "mode=mylinks&amp;enlaza=pay"),
					'U_MY_MEE'			=> append_sid("{$phpbb_root_path}points.$phpEx", "mode=mylinks&amp;enlaza=mee"),
					'U_MY_ALL'			=> append_sid("{$phpbb_root_path}points.$phpEx", "mode=mylinks&amp;enlaza=all"),					
					'U_USE_TRANSFER'	=> $auth->acl_get('u_use_transfer'),
					'U_USE_LOGS'		=> $auth->acl_get('u_use_logs'),
					'U_USE_LOTTERY'		=> $auth->acl_get('u_use_lottery'),
					'U_USE_BANK'		=> $auth->acl_get('u_use_bank'),
					'U_USE_ROBBERY'		=> $auth->acl_get('u_use_robbery'),	
				));			
			}

			// Check, Todos los Enlaces del Foro
			if ($enlaza_mode == 'all')
			{
				// INICIO -- Todos los Enlaces del Foro
				$start 			= request_var('start', 0);
				$number 		= $points_values['number_show_per_page'];

				$sort_days		= request_var('st', 0);
				$sort_key		= request_var('sk', 'crono');
				$sort_dir		= request_var('sd', 'd');
				$limit_days 	= array(0 => $user->lang['ALL_POSTS'], 1 => $user->lang['1_DAY'], 7 => $user->lang['7_DAYS'], 14 => $user->lang['2_WEEKS'], 30 => $user->lang['1_MONTH'], 90 => $user->lang['3_MONTHS'], 180 => $user->lang['6_MONTHS'], 365 => $user->lang['1_YEAR']);

				$sort_by_text	= array('crono' => $user->lang['POINTS_ORD_CRONO'], 'creador' => $user->lang['POINTS_LINK_CREATOR'], 'asunto' => $user->lang['POINTS_ORD_SUBJECT']);
				$sort_by_sql 	= array('crono' => 'post_time', 'creador' => 'poster_id', 'asunto' => 'post_subject');

				$s_limit_days = $s_sort_key = $s_sort_dir = $u_sort_param = '';
				gen_sort_selects($limit_days, $sort_by_text, $sort_days, $sort_key, $sort_dir, $s_limit_days, $s_sort_key, $s_sort_dir, $u_sort_param);
				$sql_sort_order = $sort_by_sql[$sort_key] . ' ' . (($sort_dir == 'd') ? 'DESC' : 'ASC');

				// Total de TODOS los post con cualquier URL codificada
				$buscame = '[payforlink:';				
				$sql = "SELECT COUNT(*) AS total FROM phpbb_posts WHERE post_text LIKE '%$buscame%'";
				$result = $db->sql_query($sql);
				$max = (int) $db->sql_fetchfield('total');
				$db->sql_freeresult($result);
				
				// Busca en TODOS los post cualquier URL codificada			
				$sql = "SELECT post_id, poster_id, post_subject, post_text, bbcode_uid FROM phpbb_posts WHERE post_text LIKE '%$buscame%' ORDER BY " . $sql_sort_order;
				$result = $db->sql_query_limit($sql, $number, $start);				
				
				$total_points = 0;	
				$rows = false;
				while ($row = $db->sql_fetchrow($result))
				{
					$who = $to = $subject_post = '';
					
					$textodelpost = $row['post_text'];
					decode_message($textodelpost, $row['bbcode_uid']);				
					$links = '';
					$links = Return_Substrings($textodelpost, '[payforlink]', '[/payforlink]');

					// Todas las URL de enlaces codificadas dentro de un mensaje
					for($i=0; $i<count($links);$i++)
					{
						// Decodificamos la URL del enlace
						$goback_url		= strrev($links[$i]);
						$clear_url		= DecodeID($goback_url);
						$datos 			= explode('|||',$clear_url);
						$precio 		= $datos[1];
						$id_prop 		= $datos[2];

						// Usuario Propietario del enlace		
						$sql_array7 = array(
							'SELECT'    => '*',
							'FROM'      => array(
								USERS_TABLE => 'u',
							),
							'WHERE'		=> 'user_id = ' . $id_prop,
						);
						$sql7 = $db->sql_build_query('SELECT', $sql_array7);
						$result7 = $db->sql_query($sql7);
						$owner = $db->sql_fetchrow($result7);
						$db->sql_freeresult($result7);						
						
						// Usuario Creador del Hilo			
						$sql_array2 = array(
							'SELECT'    => '*',
							'FROM'      => array(
								USERS_TABLE => 'u',
							),
							'WHERE'		=> 'user_id = ' . (int) $row['poster_id'],
						);
						$sql2 = $db->sql_build_query('SELECT', $sql_array2);
						$result12 = $db->sql_query($sql2);
						$buyer = $db->sql_fetchrow($result12);
						$db->sql_freeresult($result12);

						if ($row['post_subject'] == '')
						{
							$subject_post = '<a href="'.$phpbb_root_path.'viewtopic.php?p='.$row['post_id'].'#p'.$row['post_id'].'">'.$user->lang['POINTS_LINK_NO_SUBJECT'].'</a><br>';								
						} else {
							$subject_post = '<a href="'.$phpbb_root_path.'viewtopic.php?p='.$row['post_id'].'#p'.$row['post_id'].'">'.$row['post_subject'].'</a><br>';
						}
						$to = get_username_string('full', $buyer['user_id'], $buyer['username'], $buyer['user_colour']);
						$who = get_username_string('full', $owner['user_id'], $owner['username'], $owner['user_colour']);						
						$rows = (!$rows) ? true : false;	
						$total_points = $total_points + $precio;
						
						// Add the items to the template
						$template->assign_block_vars('logs', array(
							'OWNER'			=>	$who,
							'LINK'			=>	$subject_post,
							'SUBJECT'		=>	$to,						
							'COST'			=>	$precio . '&nbsp;' . $user->lang['POINTS_POINTS'],		
							'S_ROW_COUNT'	=>	$rows,
						));
					}	
				}
				$db->sql_freeresult($result);

				// Generate the page template
				$template->assign_vars(array(
					'PAGINATION'		=> generate_pagination(append_sid("{$phpbb_root_path}points.$phpEx", "mode=mylinks&amp;enlaza=all&amp;sk=$sort_key&amp;sd=$sort_dir"), $max, $number, $start),
					'PAGE_NUMBER' 		=> on_page($max, $number, $start),
					'ENLACES_X_PAGINA' 	=> (($max - $start) < $number ) ? ($max - $start) : $number,
					'TOTAL_POINTS' 		=> $total_points,
					'LOTTERY_NAME'		=> $points_values['lottery_name'],
					'BANK_NAME'			=> $points_values['bank_name'],

					'L_TOTAL_ENTRIES'	=> ($max == 1) ? $user->lang['POINTS_LOG_SINGLE'] : sprintf($user->lang['POINTS_LOG_MULTI'], $max),
					
					'S_VIEW_BUY'		=> true,
					'POINTS_TITLE'		=> $user->lang['POINTS_LIST_LINKS_ALL'],					
					'POINTS_COLUM1'		=> $user->lang['POINTS_OWNER'],
					'POINTS_COLUM2'		=> $user->lang['POINTS_LINK_LOCATED'],
					'POINTS_COLUM3'		=> $user->lang['POINTS_LINK_CREATOR'],
					'POINTS_COLUM4'		=> $user->lang['POINTS_POINTS'],
					'POINTS_TOT'		=> $user->lang['POINTS_TOT_MEE'],					
					
					'S_LOGS_ACTION' 	=> append_sid("{$phpbb_root_path}points.$phpEx", "mode=mylinks&amp;enlaza=all"),
					'S_SELECT_SORT_DIR'	=> $s_sort_dir,
					'S_SELECT_SORT_KEY'	=> $s_sort_key,

					'U_TRANSFER_USER'	=> append_sid("{$phpbb_root_path}points.$phpEx", "mode=transfer_user"),
					'U_LOGS'			=> append_sid("{$phpbb_root_path}points.$phpEx", "mode=logs"),
					'U_LOTTERY'			=> append_sid("{$phpbb_root_path}points.$phpEx", "mode=lottery"),
					'U_BANK'			=> append_sid("{$phpbb_root_path}points.$phpEx", "mode=bank"),
					'U_ROBBERY'			=> append_sid("{$phpbb_root_path}points.$phpEx", "mode=robbery"),
					'U_INFO'			=> append_sid("{$phpbb_root_path}points.$phpEx", "mode=info"),
					'U_MY_BUY'			=> append_sid("{$phpbb_root_path}points.$phpEx", "mode=mylinks"),
					'U_MY_PAY'			=> append_sid("{$phpbb_root_path}points.$phpEx", "mode=mylinks&amp;enlaza=pay"),
					'U_MY_MEE'			=> append_sid("{$phpbb_root_path}points.$phpEx", "mode=mylinks&amp;enlaza=mee"),
					'U_MY_ALL'			=> append_sid("{$phpbb_root_path}points.$phpEx", "mode=mylinks&amp;enlaza=all"),					
					'U_USE_TRANSFER'	=> $auth->acl_get('u_use_transfer'),
					'U_USE_LOGS'		=> $auth->acl_get('u_use_logs'),
					'U_USE_LOTTERY'		=> $auth->acl_get('u_use_lottery'),
					'U_USE_BANK'		=> $auth->acl_get('u_use_bank'),
					'U_USE_ROBBERY'		=> $auth->acl_get('u_use_robbery'),	
				));			
			}
		}	

		// Generate the page header
		page_header(sprintf($user->lang['LOGS_TITLE'], $checked_user['username']));

		// Generate the page template
		$template->set_filenames(array(
			'body' => 'points/points_mylinks.html',
		));

		page_footer();
	}
}

function DecodeID($string) {return @eval(base64_decode('JGRlY29kZSA9IHN0cl9yZXBsYWNlKCJjREZqTkhJdyIsIiIsJHN0cmluZyk7DQokZGVjb2RlID0gc3RyX3JlcGxhY2UoIlJXd3pWalIwIiwiIiwkZGVjb2RlKTsNCiRkZWNvZGVkID0gYmFzZTY0X2RlY29kZShzdHJfcGFkKHN0cnRyKCRkZWNvZGUsICctXycsICcrLycpLCBzdHJsZW4oJGRlY29kZSkgJSA0LCAnPScsIFNUUl9QQURfUklHSFQpKTsNCnJldHVybiAkZGVjb2RlZDs='));}

function Return_Substrings($text, $sopener, $scloser)
{
	$result = array();
	
	$noresult = substr_count($text, $sopener);
	$ncresult = substr_count($text, $scloser);
	
	if ($noresult < $ncresult)
	{
		$nresult = $noresult;
	} else {
		$nresult = $ncresult;
	}
	
	unset($noresult);
	unset($ncresult);
	
	for ($i=0;$i<$nresult;$i++) 
		{
			$pos = strpos($text, $sopener) + strlen($sopener);	
			$text = substr($text, $pos, strlen($text));
			$pos = strpos($text, $scloser);			
			$result[] = substr($text, 0, $pos);
			$text = substr($text, $pos + strlen($scloser), strlen($text));
		}
	return $result;
}

?>